diff -Nrc2 fontutils-0.5/bzrto/metafont.c fontutils-0.6/bzrto/metafont.c
*** fontutils-0.5/bzrto/metafont.c	Thu Sep  3 07:36:55 1992
--- fontutils-0.6/bzrto/metafont.c	Mon Oct 19 16:39:01 1992
***************
*** 20,24 ****
  
  #include "bzr.h"
! #include "char.h"
  #include "font.h"
  #include "spline.h"
--- 20,25 ----
  
  #include "bzr.h"
! #include "encoding.h"
! #include "filename.h"
  #include "font.h"
  #include "spline.h"
***************
*** 26,30 ****
--- 27,33 ----
  #include "vector.h"
  
+ #include "char.h"
  #include "input-ccc.h"
+ #include "main.h"
  #include "metafont.h"
  
***************
*** 37,56 ****
  
  
- /* Whether or not a particular character has been written.  */
- static boolean mf_char_output_p[MAX_CHARCODE + 1];
- 
- 
  /* Macros for output to `mf_file'.  */
! #define OUT1(str, arg)		    fprintf (mf_file, str, arg)
! #define OUT2(str, arg1, arg2)	    fprintf (mf_file, str, arg1, arg2)
! #define OUT3(str, arg1, arg2, arg3) fprintf (mf_file, str, arg1, arg2, arg3)
! #define OUT4(str, arg1, arg2, arg3, arg4) \
!                                  fprintf (mf_file, str, arg1, arg2, arg3, arg4)
! 
! #define OUT_LINE(str)		     OUT1 ("%s\n", str)
! #define OUT_STRING(str)		     OUT1 ("%s", str)
! #define OUT_STATEMENT(str)	     OUT1 ("%s;\n", str)
! #define OUT_PT_SHARP_ASSIGNMENT(lhs, rhs)  OUT2 ("%s := %.3fpt#;\n", lhs, rhs)
! #define OUT_U_ASSIGNMENT(lhs, rhs)  OUT2 ("%s := %.3fu;\n", lhs, rhs)
  
  #define OUT_ZASSIGNMENT(lhs, c, l, s, pt)				\
--- 40,52 ----
  
  
  /* Macros for output to `mf_file'.  */
! #define OUT1(str, a)		  fprintf (mf_file, str, a)
! #define OUT2(str, a1, a2)	  fprintf (mf_file, str, a1, a2)
! #define OUT3(str, a1, a2, a3)	  fprintf (mf_file, str, a1, a2, a3)
! #define OUT4(str, a1, a2, a3, a4) fprintf (mf_file, str, a1, a2, a3, a4)
! 
! #define OUT_LINE(str)      OUT1 ("%s\n", str)
! #define OUT_STRING(str)    OUT1 ("%s", str)
! #define OUT_STATEMENT(str) OUT1 ("%s;\n", str)
  
  #define OUT_ZASSIGNMENT(lhs, c, l, s, pt)				\
***************
*** 62,66 ****
  
  #define OUT_POINT(p) OUT2 ("(%.3fu,%.3fu)", p.x, p.y)
- #define OUT_CHAR_SUBR(c) OUT1 (INDENT "%s;\n", charcode_to_subr_name (c))
  
  /* How to indent.  */
--- 58,61 ----
***************
*** 68,75 ****
  
  
  static void out_bb_char (real_bounding_box_type *,
                           real_coordinate_type *, bzr_char_type);
  static void out_move (real_coordinate_type *, real, real, boolean);
! static void output_ligtable (char_type **);
  
  /* Start things off.  We want to write to a Metafont file, e.g.,
--- 63,77 ----
  
  
+ static string charcode_to_subr_name (charcode_type);
  static void out_bb_char (real_bounding_box_type *,
                           real_coordinate_type *, bzr_char_type);
  static void out_move (real_coordinate_type *, real, real, boolean);
! static void output_bzr_body (bzr_char_type);
! static real_bounding_box_type output_ccc_body (ccc_type, char_type *[]);
! static void output_char_title (charcode_type);
! static void output_ligtable (list_type, char_type **);
! static void output_subr_start (charcode_type code);
! static tfm_char_type **read_tfm_files (list_type);
! static void read_tfm_file (tfm_char_type *[], string);
  
  /* Start things off.  We want to write to a Metafont file, e.g.,
***************
*** 78,82 ****
  void
  metafont_start_output (string output_name, bzr_preamble_type pre, 
! 		       tfm_global_info_type info)
  {
    unsigned this_param;
--- 80,84 ----
  void
  metafont_start_output (string output_name, bzr_preamble_type pre, 
! 		       tfm_global_info_type *info)
  {
    unsigned this_param;
***************
*** 94,98 ****
    /* Output the size that our original data is based on.  The font can
       be generated at sizes different than this.  */
!   OUT_PT_SHARP_ASSIGNMENT ("true_design_size#", BZR_DESIGN_SIZE (pre));
    
    /* The real work is done in an auxiliary file.  */
--- 96,100 ----
    /* Output the size that our original data is based on.  The font can
       be generated at sizes different than this.  */
!   OUT1 ("true_design_size# := %.3fpt#;\n", BZR_DESIGN_SIZE (pre));
    
    /* The real work is done in an auxiliary file.  */
***************
*** 99,118 ****
    OUT_STATEMENT ("input bzrsetup");
  
!   /* Output the fontwide information given in INFO.  */
!   OUT1 ("font_coding_scheme := \"%s\";\n", TFM_CODING_SCHEME (info));
    OUT1 ("font_identifier := \"%s\";\n", output_name);
  
!   for (this_param = 1; this_param <= TFM_FONTDIMEN_COUNT (info);
!        this_param++)
!     OUT2 ("fontdimen %u: %.3fpt# * u#;\n", this_param,
!           TFM_FONTDIMEN (info, this_param)); 
  }
  
! /* Metafont doesn't allow numerals in identifiers, so we can't just use
!    the decimal character code to distinguish the subroutines.  Instead, we
!    use a base-16 representation where zero is `a', one is `b', ...,
     fifteen is `o'.  */
  
! #define SUBR_NAME_PREFIX  "charsubr_"
  
  static string
--- 101,179 ----
    OUT_STATEMENT ("input bzrsetup");
  
!   /* Output the fontwide information given in the global `encoding_info'.  */
!   OUT1 ("font_coding_scheme := \"%s\";\n",
!         ENCODING_SCHEME_NAME (encoding_info));
    OUT1 ("font_identifier := \"%s\";\n", output_name);
  
!   if (info)
!     for (this_param = 1; this_param <= TFM_FONTDIMEN_COUNT (*info);
!          this_param++)
!       if (TFM_FONTDIMEN (*info, this_param) != 0.0)
!         OUT2 ("fontdimen %u: %.3fpt# * u#;\n", this_param,
!               TFM_FONTDIMEN (*info, this_param)); 
! }
! 
! 
! /* Used to output the character names as ``titles'', which Metafont
!    displays and puts on proofsheets in some circumstances.  */
! 
! static void
! output_char_title (charcode_type code)
! {
!   string title = ENCODING_CHAR_NAME (encoding_info, code);
!   
!   if (title == NULL)
!     title = concat ("character #", utoa (code));
!     
!   OUT1 (INDENT "\"%s\";\n", title);
  }
  
! /* Output of subroutines.  The main part of the subroutine is done in
!    the same way as a character, it's just the adminstrative junk that's
!    different.  We have to remember some information in case this
!    subroutine later gets output as a character.  I'm not entirely sure
!    that we need it in all cases, but it seems cleaner to just always
!    save it.  */
! 
! void
! metafont_output_bzr_subr (bzr_char_type c)
! {
!   output_subr_start (CHARCODE (c));
!   output_bzr_body (c);
!   OUT_STATEMENT ("enddef");
! }
! 
! 
! void
! metafont_output_ccc_subr (ccc_type c, charcode_type code, char_type *subrs[])
! {
!   output_subr_start (code);
!   output_ccc_body (c, subrs);
!   OUT_STATEMENT ("enddef");
! }
! 
! 
! /* Output the common beginning of a subroutine.  The character name is a
!    Metafont ``title'' which gets output on proofsheets and sometimes on
!    the terminal.  */
! 
! static void
! output_subr_start (charcode_type code)
! {
!   OUT1 ("def %s = \n", charcode_to_subr_name (code));
!   output_char_title (code);
! }
! 
! 
! /* When we do need to output a subroutine, however, we have to choose a
!    name for it.  Since Metafont doesn't allow numerals in identifiers,
!    so we can't just use the decimal character code to distinguish the
!    subroutines.  Instead, we use the character name from the global
!    `encoding_info', or, if the encoding name is not strictly alphabetic
!    (e.g., `.notdef') a base-16 representation where zero is `a', ...,
     fifteen is `o'.  */
  
! #define OUT_CHAR_SUBR(c) OUT1 (INDENT "%s;\n", charcode_to_subr_name (c))
! #define SUBR_NAME_PREFIX "bzr_subr_"
  
  static string
***************
*** 119,128 ****
  charcode_to_subr_name (charcode_type code)
  {
!   unsigned high = code >> 4;
!   unsigned low = code - (high << 4);
    
!   char alpha[3] = { high + 'a', low + 'a', 0 };
    
!   return concat (SUBR_NAME_PREFIX, alpha);
  }
  
--- 180,224 ----
  charcode_to_subr_name (charcode_type code)
  {
!   string subr_name;
!   string name = ENCODING_CHAR_NAME (encoding_info, code);
! 
!   if (strspn (name, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ")
!       != strlen (name))
!     {
!       unsigned high = code >> 4;
!       unsigned low = code - (high << 4);
!       char alpha[3] = { high + 'a', low + 'a', 0 };
! 
!       subr_name = concat (SUBR_NAME_PREFIX, alpha);
!     }
!   else
!     subr_name = concat (SUBR_NAME_PREFIX, name);
!   
!   return subr_name;
! }
! 
! /* Output of characters.  Eventually we should do something about
!    italic corrections.  Also, it might be better to use a symbolic name
!    for the character code instead of hardwiring an integer constant.
!    Then different encodings could be selected at Metafont-time.  If the
!    character is already as a subroutine, just output a call.  */
! 
! void
! metafont_output_bzr_char (bzr_char_type c, char_type *subrs[])
! {
!   unsigned code = CHARCODE (c);
!   
!   OUT4 ("\nbeginchar (%d, %.3fu#, %.3fu#, %.3fu#);\n", 
!         code, CHAR_SET_WIDTH (c), CHAR_MAX_ROW (c), CHAR_DEPTH (c));
    
!   if (subrs[code])
!     OUT_CHAR_SUBR (code);
!   else
!     {
!       output_char_title (code);
!       output_bzr_body (c);
!     }
    
!   OUT_STATEMENT ("endchar");
  }
  
***************
*** 129,140 ****
  
  void
! metafont_output_char_subr (bzr_char_type c)
  {
    unsigned this_list;
-   boolean was_output = false;
-   spline_list_array_type shape = BZR_SHAPE (c);
    charcode_type code = CHARCODE (c);
! 
!   OUT1 ("def %s = \n", charcode_to_subr_name (code));
  
    /* Go through the list of splines once, assigning the control points
--- 225,257 ----
  
  void
! metafont_output_ccc_char (ccc_type c, charcode_type code, char_type *subrs[])
! {
!   real_bounding_box_type bb;
!   
!   if (subrs[code])
!     WARNING ("Sorry, CCC characters can't be subroutines yet");
!   else
!     {
!       OUT1 ("\nbegin_no_dimen_char (%d);\n", code);
! 
!       output_char_title (code);
!       bb = output_ccc_body (c, subrs);
! 
!       /* Set this character's dimensions: width, height, depth.  */
!       OUT3 (INDENT "set_char_dimens (%.3fu#, %.3fu#, %.3fu#);\n",
!             BB_WIDTH (bb), MAX_ROW (bb), -MIN_ROW (bb));
!       OUT_STATEMENT ("end_no_dimen_char");
!     }
! }
! 
! /* Output the shape in the BZR character C.  */
! 
! static void
! output_bzr_body (bzr_char_type c)
  {
    unsigned this_list;
    charcode_type code = CHARCODE (c);
!   spline_list_array_type shape = BZR_SHAPE (c);
!   boolean was_output = false;
  
    /* Go through the list of splines once, assigning the control points
***************
*** 232,264 ****
          OUT3 (INDENT INDENT "%u\\%u\\%u,\n", code, this_list, this_spline);
      }
    if (was_output)
      OUT_STRING (");\n");
-   
-   OUT_STATEMENT ("enddef");
  }
- 
- /* Output a character which only uses one subroutine.  */
  
- void
- metafont_output_bzr_char (char_type c)
- {
-   bzr_char_type bzr_char = *CHAR_BZR_INFO (c);
-   tfm_char_type tfm_char = *CHAR_TFM_INFO (c);
-   charcode_type code = CHARCODE (bzr_char);
-   
-   fprintf (mf_file, "\nbeginchar (%d, %.3fu#, %.3fu#, %.3fu#);\n", 
-            code, CHAR_SET_WIDTH (bzr_char), BZR_CHAR_MAX_ROW (bzr_char), 
-            CHAR_DEPTH (bzr_char));
  
!   if (TFM_ITALIC_CORRECTION (tfm_char) != 0)
!     OUT1 (INDENT "italcorr %.3fpt#;\n", TFM_ITALIC_CORRECTION (tfm_char));
!     
!   OUT_CHAR_SUBR (code);
!   OUT_STATEMENT ("endchar");
!   mf_char_output_p[code] = true;
! }
! 
! /* Output a character which might use more than one subroutine.
!    Changes the TFM information for that character.  */
  
  #define OUT_HMOVE(h, a) out_move (&current, h, 0.0, a)
--- 349,360 ----
          OUT3 (INDENT INDENT "%u\\%u\\%u,\n", code, this_list, this_spline);
      }
+ 
    if (was_output)
      OUT_STRING (");\n");
  }
  
  
! /* Output the definition of CCC character CCC_CHAR.  All the subroutines
!    must be defined in SUBRS.  */
  
  #define OUT_HMOVE(h, a) out_move (&current, h, 0.0, a)
***************
*** 265,271 ****
  #define OUT_VMOVE(v, a) out_move (&current, 0.0, v, a)
  
! void
! metafont_output_ccc_char (ccc_type ccc_char, char_type **chars,
!                           charcode_type ccc_code, real bzr_designsize)
  {
    unsigned this_cmd;
--- 361,366 ----
  #define OUT_VMOVE(v, a) out_move (&current, 0.0, v, a)
  
! static real_bounding_box_type
! output_ccc_body (ccc_type ccc_char, char_type *subrs[])
  {
    unsigned this_cmd;
***************
*** 274,279 ****
      = (real_bounding_box_type) { FLT_MAX, FLT_MIN, FLT_MAX, FLT_MIN };
  
-   fprintf (mf_file, "\nbegin_no_dimen_char (%d);\n", ccc_code);
- 
    for (this_cmd = 0; this_cmd < LIST_SIZE (ccc_char); this_cmd++)
      { 
--- 369,372 ----
***************
*** 284,297 ****
          case TR_SETCHAR:
            {
!             bzr_char_type bzr_char
!               = *CHAR_BZR_INFO (*chars[CCC_CHARCODE (cmd)]);
! 
!             update_real_bounding_box (&bb, current);
  
!             OUT_HMOVE (CHAR_LSB (bzr_char), false);
!             out_bb_char (&bb, &current, bzr_char);
!             OUT_HMOVE (CHAR_RSB (bzr_char), false);
! 
!             update_real_bounding_box (&bb, current);
            }
            break;
--- 377,401 ----
          case TR_SETCHAR:
            {
!             char_type subr = *subrs[CCC_CHARCODE (cmd)];
  
!             if (CHAR_CLASS (subr) == bzr_char_class)
!               {
!                 bzr_char_type bzr_char = *CHAR_BZR (subr);
!                 
!                 update_real_bounding_box (&bb, current);
!                 OUT_HMOVE (CHAR_LSB (bzr_char), false);
! 
!                 out_bb_char (&bb, &current, bzr_char);
! 
!                 OUT_HMOVE (CHAR_RSB (bzr_char), false);
!                 update_real_bounding_box (&bb, current);
!               }
!             else
!               /* We haven't implemented this yet since it doesn't seem
!                  all that necessary at the moment, and it would require
!                  figuring out a bounding box and possibly side bearings
!                  for CCC character -- certainly not impossible, but not
!                  trivial, either.  */
!               WARNING ("Sorry, I can't `setchar' a CCC char yet");
            }
            break;
***************
*** 298,303 ****
  
          case TR_SETCHARBB:
!           out_bb_char (&bb, &current,
!                        *CHAR_BZR_INFO (*chars[CCC_CHARCODE (cmd)]));
            break;
  
--- 402,413 ----
  
          case TR_SETCHARBB:
!           {
!             char_type subr = *subrs[CCC_CHARCODE (cmd)];
! 
!             if (CHAR_CLASS (subr) == bzr_char_class)
!               out_bb_char (&bb, &current, *CHAR_BZR (subr));
!             else
!               WARNING ("Sorry, I can't `setcharbb' a CCC char yet");
!           }
            break;
  
***************
*** 311,328 ****
  
          default:
!           FATAL2 ("Bad command %d in CCC character %d", CCC_OPCODE (cmd),
!                   ccc_code);
!           break;
  	}
      }
!    
!    /* Set this character's dimensions: width, height, depth.  */
!    
!   OUT3 (INDENT "set_char_dimens (%.3fu#, %.3fu#, %.3fu#);\n",
!         BB_WIDTH (bb), MAX_ROW (bb), -MIN_ROW (bb));
!   OUT_STATEMENT ("end_no_dimen_char");
!   mf_char_output_p[ccc_code] = true;
! 
!   char_make_tfm (chars, ccc_code, bb);
  }
  
--- 421,429 ----
  
          default:
!           FATAL1 ("Bad command %d in CCC character", CCC_OPCODE (cmd));
  	}
      }
!   
!   return bb;
  }
  
***************
*** 356,360 ****
  {
    /* Update BB with the current point.  */
!   update_real_bounding_box (bb, VOFFSET_POINT (BZR_CHAR_MIN_ROW (bzr_char)));
  
    /* Output the call to the character.  */
--- 457,461 ----
  {
    /* Update BB with the current point.  */
!   update_real_bounding_box (bb, VOFFSET_POINT (CHAR_MIN_ROW (bzr_char)));
  
    /* Output the call to the character.  */
***************
*** 362,378 ****
    
    /* Move by the width of the shape.  */
!   out_move (current, BZR_CHAR_BB_WIDTH (bzr_char), 0, false);
  
    /* Update the BB again with the new current point.  */
!   update_real_bounding_box (bb, VOFFSET_POINT (BZR_CHAR_MAX_ROW (bzr_char)));
  }
  
! /* We use `bye' to finish off the Metafont output, instead of the
!    primitive `end', since that makes adding cleanup operations simpler.  */
  
  void
! metafont_finish_output (char_type **chars)
  {
!   output_ligtable (chars);
    
    OUT_LINE ("\nbye.");
--- 463,480 ----
    
    /* Move by the width of the shape.  */
!   out_move (current, BB_WIDTH (CHAR_BB (bzr_char)), 0, false);
  
    /* Update the BB again with the new current point.  */
!   update_real_bounding_box (bb, VOFFSET_POINT (CHAR_MAX_ROW (bzr_char)));
  }
  
! /* We use a macro `bye' to finish off the Metafont output, instead of the
!    primitive `end', for maximal flexibility.  (Although in practice it
!    makes no difference, since `end' can be redefined just like `bye'.)  */
  
  void
! metafont_finish_output (list_type bzr_names, char_type **chars)
  {
!   output_ligtable (bzr_names, chars);
    
    OUT_LINE ("\nbye.");
***************
*** 381,392 ****
  
  
! /* True if didn't get output to `mf_file', or if the character
!    doesn't exist in the TFM file.  (The latter should only occur if the
!    TFM file being read doesn't match the bitmap file from which we
!    generated the BZR file .)  */
! 
! #define NO_CHAR_P(code) 						\
!   (!mf_char_output_p[code] 						\
!    || !TFM_CHAR_EXISTS (*(CHAR_TFM_INFO (*(chars[code])))))
  
  /* Start or continue the ligtable for the character CODE.  */
--- 483,489 ----
  
  
! /* True if the character CODE exists in the array `tfm_chars'.  */
! 
! #define HAVE_CHAR_P(code) (tfm_chars[code] != NULL)
  
  /* Start or continue the ligtable for the character CODE.  */
***************
*** 405,424 ****
  
  static void
! output_ligtable (char_type **chars)
  {
    unsigned code;
    
!   for (code = 0; code <= MAX_CHARCODE; code++)
      {
        list_type kern_list, ligature_list;
        unsigned this_kern, this_lig;
!       tfm_char_type *c = CHAR_TFM_INFO (*(chars[code]));
        boolean output_something = false;
        
!       /* If this character didn't get output, or if we don't have TFM
!          information for it, don't do anything.  */
!       if (NO_CHAR_P (code))
          continue;
!       
        /* Output the kerns.  */
        kern_list = c->kern;
--- 502,523 ----
  
  static void
! output_ligtable (list_type bzr_names, char_type **chars)
  {
    unsigned code;
+   tfm_char_type **tfm_chars = read_tfm_files (bzr_names);
    
!   for (code = starting_char; code <= ending_char; code++)
      {
        list_type kern_list, ligature_list;
        unsigned this_kern, this_lig;
!       tfm_char_type *c;
        boolean output_something = false;
        
!       /* If we don't have TFM information for CODE, don't do anything.  */
!       if (!HAVE_CHAR_P (code))
          continue;
! 
!       c = tfm_chars[code];
! 
        /* Output the kerns.  */
        kern_list = c->kern;
***************
*** 427,435 ****
            tfm_kern_type *kern = LIST_ELT (kern_list, this_kern);
  
!           if (NO_CHAR_P (kern->character))
!             continue;
! 
!           LIGTABLE_ENTRY (code);
!           OUT2 ("hex\"%x\" kern %.4fpt#", kern->character, kern->kern);
          }
        
--- 526,534 ----
            tfm_kern_type *kern = LIST_ELT (kern_list, this_kern);
  
!           if (HAVE_CHAR_P (kern->character))
!             {
!               LIGTABLE_ENTRY (code);
!               OUT2 ("hex\"%x\" kern %.3fpt#", kern->character, kern->kern);
!             }
          }
        
***************
*** 440,448 ****
            tfm_ligature_type *lig = LIST_ELT (ligature_list, this_lig);
  
!           if (NO_CHAR_P (lig->character) || NO_CHAR_P (lig->ligature))
!             continue;
! 
! 	  LIGTABLE_ENTRY (code);
!           OUT2 ("hex\"%x\" =: hex\"%x\"", lig->character, lig->ligature);
          }
  
--- 539,547 ----
            tfm_ligature_type *lig = LIST_ELT (ligature_list, this_lig);
  
!           if (HAVE_CHAR_P (lig->character) && HAVE_CHAR_P (lig->ligature))
!           {
!   	    LIGTABLE_ENTRY (code);
!             OUT2 ("hex\"%x\" =: hex\"%x\"", lig->character, lig->ligature);
!           }
          }
  
***************
*** 449,452 ****
--- 548,611 ----
        if (output_something)
          OUT_LINE (";");
+     }
+ }
+ 
+ 
+ /* We want to retain kerning and ligature information from the original
+    TFM files, if such exist.  Our goal here is to read the TFM file
+    corresponding to each name in BZR_NAMES and return the union of all
+    the characters found as an array of `tfm_char_type's.  We do not
+    complain about nonexistent TFM files.  */
+ 
+ static tfm_char_type **
+ read_tfm_files (list_type bzr_names)
+ {
+   unsigned c, name;
+   tfm_char_type **tfm_chars = XTALLOC (MAX_CHARCODE + 1, tfm_char_type *);
+   
+   /* Assume we'll find nothing.  */
+   for (c = 0; c <= MAX_CHARCODE; c++)
+     tfm_chars[c] = NULL;
+ 
+   /* Read all the files, updating the array as we go.  */
+   for (name = 0; name < LIST_SIZE (bzr_names); name++)
+     {
+       string *bzr_name = LIST_ELT (bzr_names, name);
+       
+       read_tfm_file (tfm_chars, *bzr_name);
+     }
+ 
+   return tfm_chars;
+ }
+ 
+ 
+ /* If the TFM file corresponding to BZR_NAME exists, read it and update
+    TFM_CHARS.  We do not overwrite existing TFM characters, since
+    earlier files should override later files.  (The first file is the
+    main input file.)  Arguably multiple characters should be a warning,
+    but I'm not sure.  */
+ 
+ static void
+ read_tfm_file (tfm_char_type *tfm_chars[], string bzr_name)
+ {
+   string tfm_root = make_suffix (bzr_name, "tfm");
+   string tfm_name = find_tfm_filename (tfm_root);
+ 
+   if (tfm_name != NULL && tfm_open_input_file (tfm_name))
+     {
+       unsigned code;
+       tfm_char_type *file_chars = tfm_get_chars ();
+       
+       for (code = 0; code <= MAX_CHARCODE; code++)
+         {
+           if (tfm_chars[code] == NULL && TFM_CHAR_EXISTS (file_chars[code]))
+             {
+               tfm_chars[code] = XTALLOC1 (tfm_char_type);
+               *tfm_chars[code] = file_chars[code];
+             }
+         }
+ 
+       free (file_chars);
+       tfm_close_input_file ();
      }
  }
diff -Nrc2 fontutils-0.5/bzrto/metafont.h fontutils-0.6/bzrto/metafont.h
*** fontutils-0.5/bzrto/metafont.h	Mon Aug 17 15:18:14 1992
--- fontutils-0.6/bzrto/metafont.h	Mon Oct 19 16:39:01 1992
***************
*** 28,43 ****
  /* This is called first.  */
  extern void metafont_start_output (string output_name, bzr_preamble_type, 
! 				   tfm_global_info_type);
  
! /* Then this is called for each character.  */
! extern void metafont_output_char_subr (bzr_char_type);
  
  /* Then we call one or the other of these.  */
! extern void metafont_output_bzr_char (char_type);
! extern void metafont_output_ccc_char (ccc_type, char_type **,
! 				      charcode_type, real);
  
  /* And finally this is called at the end.  */
! extern void metafont_finish_output (char_type **);
  
  #endif /* not METAFONT_H */
--- 28,43 ----
  /* This is called first.  */
  extern void metafont_start_output (string output_name, bzr_preamble_type, 
! 				   tfm_global_info_type *);
  
! /* Then these are called for characters needed as subroutines.  */
! extern void metafont_output_bzr_subr (bzr_char_type);
! extern void metafont_output_ccc_subr (ccc_type, charcode_type, char_type *[]);
  
  /* Then we call one or the other of these.  */
! extern void metafont_output_bzr_char (bzr_char_type, char_type *[]);
! extern void metafont_output_ccc_char (ccc_type, charcode_type, char_type *[]);
  
  /* And finally this is called at the end.  */
! extern void metafont_finish_output (list_type, char_type **);
  
  #endif /* not METAFONT_H */
